﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class EndGameRoundup : MonoBehaviour {
	public Text TotalTime;
	public Text LevelOneTime;
	public Text LevelTwoTime;
	public Text LevelThreeTime;
	public Text LevelFourTime;
	public Text BestTime;
	public Text BestTimeRunnerUp;
	public Text BestTimeSecondRunnerUp;

	// Use this for initialization
	void Start () {
		float ThisGameTotalTime = GameManager.GetTotalTime();
		Dictionary<string, float> LevelTimes = GameManager.GetLevelTimes();
		float[] bestTotalTimes = GameManager.GetBestTotalTimes();
		bool madeTheTopThree = false;

		int position;
		Debug.LogFormat("Final time was {0}", ThisGameTotalTime);

		for(position = bestTotalTimes.Length-1; position>=0; position--){
			float gameTime = bestTotalTimes[position];
			if(ThisGameTotalTime < gameTime || gameTime == 0 || gameTime == float.PositiveInfinity){
				Debug.LogFormat("You beat position {0}!", position);
				madeTheTopThree = true;
			} else {
				break;
			}
		}


		if(madeTheTopThree){
			position++;
			Debug.LogFormat("You came in {0}th place!", position);

			switch(position){
				case 0:
					BestTime.color = new Color(1.0f, 1.0f, 0.5f);
					break;

				case 1:
					BestTimeRunnerUp.color = new Color(1.0f, 1.0f, 0.5f);
					break;

				case 2:
					BestTimeSecondRunnerUp.color = new Color(1.0f, 1.0f, 0.5f);
					break;
			}

			float[] newBestTimes = new float[bestTotalTimes.Length];
			print("New Best times are:");

			for(int i=0; i<3; i++){
				float time;

				if(i<position){
					time = bestTotalTimes[i];
				} else if(i==position){
					time = ThisGameTotalTime;
				} else if(i > position && i < 2){
					time = bestTotalTimes[i+1];
				} else {
					continue;
				}
				if(time > 0){
					Debug.LogFormat("  {0}: {1}", i, time);
					newBestTimes[i] = time;
				}
			}

			GameManager.SetBestTotalTimes(newBestTimes);
			bestTotalTimes = GameManager.GetBestTotalTimes();
		}

		TotalTime.text = PlayerHUDController.GetFormattedTime(ThisGameTotalTime);

		LevelOneTime.text = PlayerHUDController.GetFormattedTime(LevelTimes["Level 1"]);
		LevelTwoTime.text = PlayerHUDController.GetFormattedTime(LevelTimes["Level 2"]);
		LevelThreeTime.text = PlayerHUDController.GetFormattedTime(LevelTimes["Level 3"]);
		LevelFourTime.text = PlayerHUDController.GetFormattedTime(LevelTimes["Level 4"]);

		BestTime.text = PlayerHUDController.GetFormattedTime(bestTotalTimes[0]);
		BestTimeRunnerUp.text = PlayerHUDController.GetFormattedTime(bestTotalTimes[1]);
		BestTimeSecondRunnerUp.text = PlayerHUDController.GetFormattedTime(bestTotalTimes[2]);
	}
}
